﻿------------------------------------------------------------------------------------------
--Crowd Control module--------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local RI = LibStub("LibRaidInspect-1.0")

function SN:CrowdCtrl()
	
	F.cc = T:NewGroup(SN.data.profile.cc.width, "CC Frame", crowdcontrol, M.media.draghandle)
	F.cc:SetSorting("label")
	F.cc:SetSpacing(0, 3)
	F.cc:SetStartPoint(SN.data.profile.cc.grow)
	F.cc:SetPoint(unpack(SN.data.profile.frames.cc))
	
	if SN.data.profile.cc.iconmode then
		F.cc:SetIconMode(32 * SN.data.profile.cc.iconscale, "BOTTOM", 0, 0)
		F.cc:SetSpacing(SN.data.profile.cc.fontsize / 2, SN.data.profile.cc.fontsize + 3)
	end
	F.cc:SetScript("OnEvent", function(self, event, ...)
		SN:UpdateCC(self, event, ...)
	end)
	F.cc:RegisterEvent("UNIT_AURA")
	F.cc:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:UpdateCC(self, event, ...)
	if event == "UNIT_AURA" then
		local UnitID = ...
		if UnitIsEnemy(UnitID, "player") ~= nil then
			local i = 1
			while true do
				local name, _, _, _, _, dur, expirationTime, sourceName, _, _, spellId, canApplyAura = UnitDebuff(UnitID, i)
				--Is there a bar for this debuff already?
				if not name then break end
				local cc = self:Find("SN:arg5", name)
				if cc == nil and expirationTime ~= nil then
					for _, ccontrol in pairs(SN.crowdcontrol) do
						if ccontrol == spellId then
							SN:CreateBar(self, spellId, (expirationTime - GetTime()), UnitName(sourceName), UnitGUID(UnitID), name,
							SN.data.profile.cc.width, SN.data.profile.cc.height, SN.data.profile.cc.fontsize, LSM:Fetch("font", SN.data.profile.cc.font),
									LSM:Fetch("statusbar", SN.data.profile.cc.texture))
							for i in pairs(self.bars) do
								if i:GetData("SN:arg2") == spellId then
									i:SetDuration((expirationTime - GetTime()), dur)
									i:Start()
								end
							end
						end
					end
				end
				i = i + 1
			end
		end
	end
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellId, spellName = select(12, ...)
		
		if type == "SPELL_AURA_REMOVED" then
			for _, ccontrol in pairs(SN.crowdcontrol) do
				if ccontrol == spellId then
					local cc = self:Find("SN:arg2", spellId)
					if cc ~= nil then
						if LibRaidInspectMembers[sourceGUID]["role"] ~= "TANK" then
							local bit
							if GetNumGroupMembers() > 5 and IsInRaid() then
								bit = true
							elseif GetNumGroupMembers() > 1 and not IsInRaid() then
								bit = false
							end
							SN:Announcer(self, nil, spellId, sourceName, destName, bit)
						end
						cc:Stop()
					end
				end
			end
		end
		
	end
end

function IsUnitPlayer(guid) 
	local guid = strsub(guid, 1 ,5)
	if(bit.band(guid, 0x00F) == 0) then 
		return true
	end
	return false
end

function SN:CCEnable()
	if not F.cc:IsVisible() then
		F.cc:Show()
	end
	F.cc:RegisterEvent("UNIT_AURA")
	F.cc:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:CCDisable()
	F.cc:UnregisterEvent("UNIT_AURA")
	F.cc:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.cc:Hide()
end